/*******************************************************************************
*  LogWriter.cpp - Configure the program
*
*  Berzerk/
*
*  Part of the BuckoSoft Network Monitor
*  Copyright 2009 - BuckoSoft, Inc.
*
*  http://cvs.buckosoft.com/Projects/Berzerk/Berzerk/Berzerk/LogWriter.cpp
*
*  $Id: LogWriter.cpp,v 1.3 2009/10/09 04:09:45 dick Exp $
*
*  With which we configure Berzerk
\*******************************************************************************/

/*
 *  $Log: LogWriter.cpp,v $
 *  Revision 1.3  2009/10/09 04:09:45  dick
 *  Use localtime for the logs.
 *
 *  Revision 1.2  2009/10/05 22:14:30  dick
 *  Programmable logLevel and logFormat.
 *
 *  Revision 1.1  2009/10/05 07:52:19  dick
 *  Write Berzerk's log files.
 *
 */

#include "stdafx.h"
#include "../config.h"

#include <string>
#include <iostream>
#include <fstream>
#include <time.h>

#include <boost/foreach.hpp>
#include <boost/algorithm/string.hpp>

using namespace std;
using namespace boost;

#include "LogWriter.h"
#include "Berzerk.h"

int LogWriter::DEBUG = 0;


///////////////////////////////////////////////////////////////////////////////
LogWriter::LogWriter() {
	logFileName = VARLOG_DIR;
	logFileName += "/berzerk.log";
}

///////////////////////////////////////////////////////////////////////////////
void LogWriter::log(int level, const char* logLine) {

	if (level > this->logLevel)
		return;

	ofstream	file;

	file.open(logFileName.c_str(), ios::app | ios::out);
	if (file.good()) {
		file << getTimestamp() << " " << logLine << endl;
	}
	file.close();

}

///////////////////////////////////////////////////////////////////////////////
string	LogWriter::getTimestamp() {
	char	s[256];
	struct tm*	tm;
	time_t t = time(NULL);
	tm = localtime(&t);
	//tm = gmtime(&t);
	strftime(s, 255, logFmt.c_str(), tm);
	string st = s;
	return(st);
}
