/*******************************************************************************
*  LogWriter.h - Write Berzerk's log file
*
*  Berzerk/
*
*  Part of the BuckoSoft Network Monitor
*  Copyright 2009 - BuckoSoft, Corp.
*
*  http://cvs.buckosoft.com/Projects/Berzerk/Berzerk/Berzerk/LogWriter.h
*
*  $Id: LogWriter.h,v 1.2 2009/10/05 22:14:30 dick Exp $
*
*  With which we log Berzerk's activities
\*******************************************************************************/

/*
 *  $Log: LogWriter.h,v $
 *  Revision 1.2  2009/10/05 22:14:30  dick
 *  Programmable logLevel and logFormat.
 *
 *  Revision 1.1  2009/10/05 07:52:19  dick
 *  Write Berzerk's log files.
 *
 */

#ifndef	_LOGWRITER_H_
#define	_LOGWRITER_H_

#include <string>
#include <list>
using namespace std;

class Berzerk;

class LogWriter {
  public:
	LogWriter();
	//void	setFileName(const string& outputLogFileName);
	void	setLogFmt(const string& fmt);

	void	setLogLevel(int logLevel);
	int		getLogLevel();

	void	log(int level, const string& logLine);
	void	log(int level, const char* logLine);

	void			setBerzerk(Berzerk* berzerk);
	static void		setDEBUG(int value);

  protected:
	string	getTimestamp();

  private:
	int				logLevel;
	string			logFmt;
	Berzerk*		berzerk;
	string			logFileName;

	static int		DEBUG;
};

inline void LogWriter::setBerzerk(Berzerk* bz) { berzerk = bz; };
inline void LogWriter::setDEBUG(int level) { DEBUG = level; }

inline void LogWriter::setLogLevel(int l) { logLevel = l; }
inline int  LogWriter::getLogLevel() { return(logLevel); }

inline void LogWriter::log(int level, const string& logLine) { this->log(level, logLine.c_str()); }
inline void LogWriter::setLogFmt(const string& fmt) { this->logFmt = fmt; }
#endif		// _LOGWRITER_H_
