/*******************************************************************************
*  StatServer - Manage Statistics and give reports
*
*  Berzerk/
*
*  Part of the BuckoSoft Network Monitor
*  Copyright 2011 - BuckoSoft, Inc.
*
\*******************************************************************************/

#ifndef	_STATSERVER_H_
#define	_STATSERVER_H_

#include "server/reply.hpp"
#include "server/RequestProcessor.hpp"
#include "Statistics.h"

using namespace http::server;

#if 0
XERCES_CPP_NAMESPACE_BEGIN
	class DOMDocument;
XERCES_CPP_NAMESPACE_END
XERCES_CPP_NAMESPACE_USE
#endif

namespace berzerk {

using namespace statistics;

class StatServer : public http::server::RequestProcessor {
  public:
	void setStatistics(Statistics* statistics);
	reply::status_type		handleRequest(const  std::string& uri, reply& rep);

  private:
	Statistics*	statistics;

	reply::status_type	doIndex(reply& rep);
	reply::status_type	doStatistics(string args, reply& rep);

	string		toXML(StatLine* sl);

#if 0
	string				domToString(DOMDocument* doc);
#endif
};

inline void StatServer::setStatistics(Statistics* s) { statistics = s; }

}	// namespace berzerk
#endif	// _STATSERVER_H_
